/*  ejemplo3.c
 *  Este programa textura una imagen de una fotografa
 *  sobre dos rectngulos. Se utiliza la opcin de texturar
 *  ampliando y repitiendo la textura.
 */
#include "glos.h"
#include <stdio.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glaux.h>


void myinit(void);
void CargaImagen(void);
void CALLBACK myReshape(GLsizei w, GLsizei h);
void CALLBACK display(void);




#define AnchoImagen 256 		
#define AltoImagen 256 
GLubyte checkImage[AnchoImagen][AltoImagen][3];

void CargaImagen(void)
{	//Para cargar una imagen en formato RAW
	int i, j;
	FILE *file;
	file=fopen("image.RAW","rb");
	if (file==NULL) { printf("Error fichero\n"); exit(1); }

	for (i = 0; i < AnchoImagen; i++) {
    for (j = 0; j < AltoImagen; j++) {
    fread(&checkImage[i][j], sizeof(char), 3*256*256, file);
	fclose(file);

    }
    }


}

void myinit(void)
{    
  glClearColor (0.0, 0.0, 0.0, 0.0);
  glEnable(GL_DEPTH_TEST);
  glDepthFunc(GL_LESS);

  CargaImagen();
  glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
    
	glTexImage2D(GL_TEXTURE_2D, 0, 3, AnchoImagen, 
    AltoImagen, 0, GL_RGB, GL_UNSIGNED_BYTE, 
	&checkImage[0][0][0]);

    
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
  glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
  glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);
  glEnable(GL_TEXTURE_2D);
  glShadeModel(GL_FLAT);
}

void CALLBACK display(void)
{
    
	//a la izq. las coordenadas del recuadro de textura
	//a la derecha las coordenadas de los 4 vertices de los rectangulos en 3D
	
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  glBegin(GL_QUADS);
	
  glTexCoord2f(0.0, 0.0); glVertex3f(0.0, 1.0, 0.0);
  glTexCoord2f(0.0, 0.5); glVertex3f(0.0, -1.0, 0.0);
  glTexCoord2f(0.5, 0.5); glVertex3f(-2.0, -1.0, 0.0);
  glTexCoord2f(0.5, 0.0); glVertex3f(-2.0, 1.0, 0.0);

	glTexCoord2f(0.0, 0.0); glVertex3f(1.41421, 1.0, -1.41421);
  glTexCoord2f(0.0, 2.0); glVertex3f(1.41421, -1.0, -1.41421);
  glTexCoord2f(2.0, 2.0); glVertex3f(0.0, -1.0, 0.0);
  glTexCoord2f(2.0, 0.0); glVertex3f(0.0, 1.0, 0.0);

	glEnd();
  glFlush();
}

void CALLBACK myReshape(GLsizei w, GLsizei h)
{
  h = (h == 0) ? 1 : h;
  glViewport(0, 0, w, h);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(60.0, 1.0*(GLfloat)w/(GLfloat)h, 1.0, 30.0);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  glTranslatef(0.0, 0.0, -3.6);
}

int main(int argc, char** argv)
{
  auxInitDisplayMode (AUX_SINGLE | AUX_RGB | AUX_DEPTH16);
  auxInitPosition (0, 0, 500, 500);
  auxInitWindow ("Textura ampliada y textura repetida");
  myinit();
  auxReshapeFunc (myReshape);
  auxMainLoop(display);
  return(0);
}
